blob: 7ee983451e96592dd106286bc2591ed965b81b5d [file] [log] [blame]
Philipp Maier7f340852018-07-10 16:21:54 +02001#!/bin/bash
2
3# Utility to verify the functionality of pysim-prog.py
4#
5# (C) 2018 by Sysmocom s.f.m.c. GmbH
6# All Rights Reserved
7#
8# Author: Philipp Maier
9#
10# This program is free software: you can redistribute it and/or modify
11# it under the terms of the GNU General Public License as published by
12# the Free Software Foundation, either version 2 of the License, or
13# (at your option) any later version.
14#
15# This program is distributed in the hope that it will be useful,
16# but WITHOUT ANY WARRANTY; without even the implied warranty of
17# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18# GNU General Public License for more details.
19#
20# You should have received a copy of the GNU General Public License
21# along with this program. If not, see <http://www.gnu.org/licenses/>.
22
23PYSIM_PROG=../pySim-prog.py
24PYSIM_READ=../pySim-read.py
25TEMPFILE=temp.tmp
26
27set -e
28
29echo "pysim-test - a test program to test pysim-prog.py"
30echo "================================================="
31
32# Generate a list of the cards we expect to see by checking which .ok files
33# are present
34function gen_card_list {
35 N_CARDS=0
36
37 echo "Expecting to see the following cards:"
38
39 for I in *.data ; do
40 CARD_NAMES[$N_CARDS]=${I%.*}
41 CARD_SEEN[$N_CARDS]=0
42 N_CARDS=$((N_CARDS+1))
43 done
44
45 for I in $(seq 0 $((N_CARDS-1))); do
46 echo ${CARD_NAMES[$I]}
47 done
48}
49
50# Increment counter in card list for a specified card name (type)
51function inc_card_list {
52 CARD_NAME=$1
53 for I in $(seq 0 $((N_CARDS-1))); do
54 if [ $CARD_NAME = ${CARD_NAMES[$I]} ]; then
55 CARD_SEEN[$I]=$((${CARD_NAMES[$I]}+1))
56 fi
57 done
58}
59
60# Check the card list, each card must be seen exactly one times
61function check_card_list {
62 for I in $(seq 0 $((N_CARDS-1))); do
63 if [ ${CARD_SEEN[$I]} -ne 1 ]; then
64 echo "Error: Card ${CARD_NAMES[$I]} seen ${CARD_SEEN[$I]} times!"
65 exit 1
66 fi
67 done
68
69 echo "All cards seen -- everything ok!"
70}
71
72# Verify the contents of a card by reading them and then diffing against the
73# previously created .ok file
74function check_card {
75 TERMINAL=$1
76 CARD_NAME=$2
77 echo "Verifying card ..."
78 stat ./$CARD_NAME.ok > /dev/null
79 python $PYSIM_READ -p $TERMINAL > $TEMPFILE
80 set +e
Philipp Maierff84c232020-05-12 17:24:18 +020081 CARD_DIFF=$(diff $TEMPFILE ./$CARD_NAME.ok)
Philipp Maier7f340852018-07-10 16:21:54 +020082 set -e
83
84 if [ "$CARD_DIFF" != "" ]; then
85 echo "Card contents do not match the test data:"
86 echo "Expected: $CARD_NAME.ok"
87 echo "------------8<------------"
88 cat "$CARD_NAME.ok"
89 echo "------------8<------------"
90 echo "Got:"
91 echo "------------8<------------"
92 cat $TEMPFILE
93 echo "------------8<------------"
Philipp Maier07cd4812019-12-31 17:53:48 +010094 rm *.tmp
Philipp Maier7f340852018-07-10 16:21:54 +020095 exit 1
96 fi
97
98 inc_card_list $CARD_NAME
99
100 echo "Card contents match the test data -- success!"
Philipp Maierff84c232020-05-12 17:24:18 +0200101 rm $TEMPFILE
Philipp Maier7f340852018-07-10 16:21:54 +0200102}
103
104# Read out the card using pysim-read and store the result as .ok file. This
105# data will be used later in order to verify the results of our write tests.
106function gen_ok_file {
107 TERMINAL=$1
108 CARD_NAME=$2
109 python $PYSIM_READ -p $TERMINAL > "$CARD_NAME.ok"
110 echo "Generated file: $CARD_NAME.ok"
111 echo "------------8<------------"
112 cat "$CARD_NAME.ok"
113 echo "------------8<------------"
114}
115
116# Find out the type (card name) of the card that is installed in the specified
117# reader
118function probe_card {
119 TERMINAL=$1
120 RESULT=$(timeout 5 $PYSIM_PROG -p $TERMINAL -T | cut -d ":" -f 2 | tail -n 1 | xargs)
121 echo $RESULT
122}
123
124# Read out all cards and store the results as .ok files
125function gen_ok_files {
126 echo "== OK FILE GENERATION =="
127 for I in $(seq 0 $((N_TERMINALS-1))); do
128 echo "Probing card in terminal #$I"
129 CARD_NAME=$(probe_card $I)
130 if [ -z "$CARD_NAME" ]; then
131 echo "Error: Unresponsive card!"
132 exit 1
133 fi
134 echo "Card is of type: $CARD_NAME"
135 gen_ok_file $I $CARD_NAME
136 done
137}
138
139# Execute tests. Each card is programmed and the contents are checked
140# afterwards.
141function run_test {
142 for I in $(seq 0 $((N_TERMINALS-1))); do
143 echo "== EXECUTING TEST =="
144 echo "Probing card in terminal #$I"
145 CARD_NAME=$(probe_card $I)
146 if [ -z "$CARD_NAME" ]; then
147 echo "Error: Unresponsive card!"
148 exit 1
149 fi
150 echo "Card is of type: $CARD_NAME"
151
152 # Make sure some default data is set
153 MCC=001
154 MNC=01
155 ICCID=1122334455667788990
156 KI=FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
157 OPC=FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
158 IMSI=001010000000001
Supreeth Herle5a541012019-12-22 08:59:16 +0100159 MSISDN=6766266
Philipp Maier7f340852018-07-10 16:21:54 +0200160 ADM=00000000
Philipp Maier4e724392019-12-12 17:02:22 +0100161 ADM_HEX=""
Daniel Willmannf432b2b2018-06-15 07:31:50 +0200162 ADM_OPT="-a"
Philipp Maier7f340852018-07-10 16:21:54 +0200163
Daniel Willmannf432b2b2018-06-15 07:31:50 +0200164 source "$CARD_NAME.data"
165 if [ -n "$ADM_HEX" ]; then
166 ADM_OPT="-A"
167 ADM=$ADM_HEX
168 fi
Supreeth Herle5a541012019-12-22 08:59:16 +0100169 python $PYSIM_PROG -p $I -t $CARD_NAME -o $OPC -k $KI -x $MCC -y $MNC -i $IMSI -s $ICCID --msisdn $MSISDN $ADM_OPT $ADM
Philipp Maier7f340852018-07-10 16:21:54 +0200170 check_card $I $CARD_NAME
171 echo ""
172 done
173}
174
175function usage {
176 echo "Options:"
177 echo "-n: number of card terminals"
178 echo "-o: generate .ok files"
179}
180
181# Make sure that the pathes to the python scripts always work, regardless from
182# where the script is called.
183CURDIR=$PWD
184SCRIPTDIR=$(dirname $0)
185cd $SCRIPTDIR
186PYSIM_PROG=$(realpath $PYSIM_PROG)
187PYSIM_READ=$(realpath $PYSIM_READ)
188cd $CURDIR
189
190OPT_N_TERMINALS=0
191OPT_GEN_OK_FILES=0
192while getopts ":hon:" OPT; do
193 case $OPT in
194 h)
195 usage
196 exit 0
197 ;;
198 o)
199 OPT_GEN_OK_FILES=1
200 ;;
201 n)
202 OPT_N_TERMINALS=$OPTARG
203 ;;
204 \?)
205 echo "Invalid option: -$OPTARG" >&2
206 exit 1
207 ;;
208 esac
209done
210
211N_TERMINALS=$OPT_N_TERMINALS
212
213# Generate a list of available cards, if no explicit reader number is given
214# then the number of cards will be used as reader number.
215gen_card_list
216if [ $N_TERMINALS -eq 0 ]; then
217 N_TERMINALS=$N_CARDS
218fi
219echo "Number of card terminals installed: $N_TERMINALS"
220echo ""
221
222if [ $OPT_GEN_OK_FILES -eq 1 ]; then
223 gen_ok_files
224 exit 0
225else
226 run_test
227 check_card_list
228 exit 0
229fi